# Consumer Wiki

## Introduction of DroneOA ROS

Drones are used in an unprecedented number of ways since the advent, with millions of people using it for agriculture, journalism, photography, courier services, etc. Seeing this opportunity, we propose to develop some solutions that make the development of drone applications easier (Including drone obstacle avoidance development) and make the drones safer at a lower altitude.

**DroneOA ROS** is a software package we have been working on to tackle this target. It provides:

- A set of unified interfaces for popular sensors and Mavlink based flight controllers
- Integrated obstacle avoidance features
- Development tool kit which consists of a UE4 based simulator, debug visualizer and debug tools
- A new simplified console command interface or a **console command "API"** for app developers
- An internal low-level control API (e.g. channel override, reset/switch communication link) for core feature developers.
- Application manager which allows installing new apps with simply a URL of its repository.
- A simplified Web-based UI API and a sample UI
- Easy to environment setup tools and prebuild and tested OS images of development/deploy environment.
- Full ROS Support and Open source

The goal of this project is to build an SDK that simplifies the development of automated drone and drone-related applications. It can also smooth the learning curve for new drone developers.

## For Advance Drone Operators
Advance drone operator can use this platform to add obstacle avoidance features and customizable network based ground stations to their existing drone (Has to use mavlink as communication protocal at the moment). Combine with 4G+ mobile network, the operator could ideally achieve unlimited range semi-automatic flight. In addition, advance drone operator can also try out the experimental features from official repo or community. Cool latest technology can be added to the user's existing drone easily and developers can also benefit from test reaults and feedbacks from drone operators.

## Content Table
- [WebGUI](GUI/GUIIndex.md)

## Credit
DroneOA Group 2020 :palm_tree:
