# GUI (In Development)

To connect to the plane, use the correct IP address (if nothing is changed, the default IP and port should work) and click on "Connect".

## Dependancies
- ROSBridge
  ```
  sudo apt-get install ros-<rosdistro>-rosbridge-server
  ```
- DroneOA ROS project

## How to launch
- **Ensure you have at least the following nodes/apps up and running**
  - sim_vehicle - This is the SITL simulation instance of Ardupilot
  - DRONEOA
    - step1* - This launches all dependance nodes for droneoa ros project
    - step2 - This is the main node of droneoa ros project
- **Launch a ROS Bridge on vehicle for the web interface:**
  - `roslaunch ./launch/websocket_ros.launch`
  - You can modify port number in the launch file
- **Launch the web GUI**
  - Option 1: use VSCode
    - Install plugin `Live Server`
    - Open `main.html` page by right click and choose `Open With Live Server`
  - Option 2: setup a local server
    - WIP

## How to use
- Choose ROSBridge port number by editing the `websocket_ros.launch` file on the vehicle
- **Enter you vehicle IP and Port to connect the GUI and ROS.** Default is `0.0.0.0` or `localhost` on port `9090` for typical local test environment
- Once connected. **The connection status should be `connected`.** Refresh the page and check configuration if status is unknown, error or closed
- The **Joystick** can be use to directly maniplate the aircraft.

## Information Panel

![Info Panel](Pic/InfoPanel.png)
The block on the top shows the following information:
- Connection: Shows if you have successfully connected to the drone.
- Flight mode: The current flight mode of the plane.
- Altitude.
- Battery Voltage: The output voltage of the battery. Dropping voltage means the battery is close to running out of power.
- Ground Speed.
- Climb Rate.
- Heading: The north is considered as 0 degree.
- Throttle.

## Command Queue

![Command Queue](Pic/CMDQueue.png)
The GUI now supports command queue input. A valid command queue can be given here the drone will follow the command queue once "Send" is clicked. Click on "[CMD Help](http://droneoa.tuotuogzs.net/droneoa_gitbook/Developer/Knowledge/Modules/Command.html#command-queue)." button for more details on commands.

## Control Panel

![Control Panel](Pic/CtrlPanel.png)
This panel provides some shortcuts for basic functions.
- ARM: Start the motor of the plane.
- RTL: Return to land, try to return to the location where it takeoff.
- LAND: Attempt to land.
- Takeoff \[Altitude\]: Takeoff and proceed to the altitude specified.
- SetYaw \[Heading\]: Change the yaw / heading of the vehicle. Can be used to direct the sensors
- Change Mode \[Mode\]: Change the mode of the drone to the mode specified.

## Joystick

Can control the plane directly, just like playing a RC drone or controlling the movement of your PUBG Mobile character :)

It can only control the speed and the heading(direction). The altitude must be changed in the Control Panel.

![Joystick at rest](Pic/JoystickRest.png)

A joystick at rest.

![Joystick triggered](Pic/JoystickInUse.png)

A triggered joystick.

