# Debug Feature

### Debug Log

All modules using ROS standard print and logging system.

The developer can directly check the ros log and memory dump to debug.

### Debug Visualizations

Debug Visualizations are used to display sensor data and system status in real time.

The debug popups are designed to use observer pattern. Developer can add there own debug popup if desired.

Modify based on existing popups are highly recommended.

[How to create new debug popups](Modules/GUI/AddNewPopup.md)

## Command and Control (CNC) Popup
- Enable & Disable by: **DEBUG_CNC_POPUP**

![Depth Debug Popup](Pic/CNCPopup.gif)

Figure 1.
- Display basic statis info, GPS info, attitude info, HUD data and waypoints in real time
- Checkout `include/droneoa_ros/GUI/GUISubscriber.hpp` to add more information to the popup.

## Depth Image Popup
- Enable & Disable by: **IMG_DEBUG_POPUP**

![Depth Debug Popup](Pic/DepthDebugPopup.gif)

Figure 2.

## PointCloud Viewer
- Enable & Disable by: **PCL_DEBUG_VIEWER**

![PCL Viewer](Pic/PCLViewer.gif)

Figure 3.

## Lidar Sector Popup
- Enable & Disable by: **DEBUG_LIDAR_POPUP**

![Lidar Popup](Pic/LidarPopup.gif)

Figure 4.
- Blue circle represents the center of the lidar
- Red dot circles represent lidar sector data (By default the sector unit is 1 degree)
- Line from center to sector data point represent the closest sector
