# Add New Popup

## Introduction
The Popup GUIs are designed to use observer pattern.

The main purposes of GUI popups are debugging and real time data Visualizations.

**For user two-way interactions, please use the Web-GUI system.**

The provided example popups use OpenCV library. But theoretically, developers can use anything they want to build the popup GUI display.

## Observer Pattern of Debug Popups
![Observer Pattern](pics/observer_pattern.PNG)

## Subject
This is the parent of all data classes that publish data and updates to GUI popups. It represents a subject that can be registered with one or more subscribers in observer pattern.
- `std::vector<GUISubscriber*> mSubscriberList` This stores the pointers of all registered subscribers
- `virtual void notifyGUIPopups()` This will call the UpdateView of all the subscribers in the `mSubscriberList` the pointer of current subject will also be passed to the subscriber.
- `GUISubject()` Default constructor.
- `virtual void registerGUIPopup(GUISubscriber* gui)` This function will add a new subscriber to the `mSubscriberList` if the incoming gui pointer is valid.

## Subscriber
This is the parent of all GUI popups. It represents a subscriber of subject in observer pattern.
- `std::string OPENCV_WINDOW_NAME` This variable will store the name of the popup window.
- `explicit GUISubscriber(std::string windowName)` The constructor require a unique popup name for 
- `virtual void UpdateView(GUISubject *subject = nullptr)` The UpdateView function is called by the subject on each `notifyGUIPopups`. Developers can use the subject pointer to determine who is the requester of this update if necessary.
