# OAC Use Cases
Note: OA = Obstacle Avoidance
## Use Case: Generic use case for OAC
<table class="tableizer-table">
<tbody>
 <tr><td>User</td><td>UI</td><td>SYS</td><td>Drone</td></tr>
 <tr><td>1. Command to arm the drone and takeoff</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>2. Arm the drone and takeoff</td></tr>
 <tr><td>3. User gives a target location</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>4. Show the desired target location on the map</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>5. Feed the initial input to the OAC module schedule and run different algorithms. Collect first set of output data and then send It to flight control unit</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>6. Fly to the intermediate waypoints and sense physical data</td></tr>
 <tr><td>&nbsp;</td><td>7. Display the intermediate flight path</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>8. Continuously pass sensor data to the algorithms. Schedule different algorithms for output due to their runtime. Collect the fastest and give it to the flight control unit</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>9. Fly to the intermediate waypoints and sense physical data. Repeat step 8-9.</td></tr>
</tbody></table>

### Alternative for step 3
(Note this also applies to exceptions)

<table class="tableizer-table">
<tbody>
 <tr><td>User</td><td>UI</td><td>SYS</td><td>Drone</td></tr>
 <tr><td>3. User provides a path instead of a single target location.</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>4. Show the user-specified path on the map</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>5. Feed the initial input to the OAC module schedule and run different algorithms. Collect first set of output data and then send It to flight control unit</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>6. Fly to the intermediate waypoints</td></tr>
 <tr><td>&nbsp;</td><td>7. Display the intermediate flight path</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>8. Continuously pass sensor data to the algorithms. Schedule different algorithms for output due to their runtime. Collect the fastest and give it to the flight control unit</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>9. Fly to the intermediate waypoints and sense physical data. Repeat step 8-9.</td></tr>
</tbody></table>

### Alternative for step 3

<table class="tableizer-table">
<tbody>
 <tr><td>User</td><td>UI</td><td>SYS</td><td>Drone</td></tr>
 <tr><td>3. User types a series of strings that is not a command</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>4. Command Queue is empty</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>5. Keep current position (stay in air)</td></tr>
 <tr><td>&nbsp;</td><td>6. Notify user that the previous instructions is invalid, then provide help instructions or possible fixes</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>7. The user gives next instruction</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>8. Continue to step 8-9 in generic when receiving instructions</td><td></td></tr>
</tbody></table>

### Exception at step 2

<table class="tableizer-table">
<tbody>
 <tr><td>User</td><td>UI</td><td>SYS</td><td>Drone</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>2. Low battery</td></tr>
 <tr><td>&nbsp;</td><td>3. Display low-battery warning</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>4. Prepare to land</td></tr>
</tbody></table>

### Exception at step 4

<table class="tableizer-table">
<tbody>
 <tr><td>User</td><td>UI</td><td>SYS</td><td>Drone</td></tr>
 <tr><td>&nbsp;</td><td>4. The GUI is disconnected with the background system and cannot display the path/location.</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>5. Display error message describing the GUI disconnection..</td><td>&nbsp;</td><td></td></tr>
</tbody></table>

### Exception at step 5

<table class="tableizer-table">
<tbody>
 <tr><td>User</td><td>UI</td><td>SYS</td><td>Drone</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>5. Some of the algorithms return with an error message that describes the failure.</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>6. Reset the failed algorithms. Enable collision avoidance feature if failure is not recoverable.</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>7. Inform the user that some algorithms don't work properly</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>8. Repeat step 5</td><td></td></tr>
</tbody></table>


### Exception at step 5

<table class="tableizer-table">
<tbody>
 <tr><td>User</td><td>UI</td><td>SYS</td><td>Drone</td></tr>
 <tr><td>5. If the user enables only the first level OA(collision avoidance)</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>6. Only enable the first level OA</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>7. Fly to the target location, if there is an obstacle in critical distance, report to OAC</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>8. Send brake command to the drone</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>9. Drone brake before colliding with the obstacle.</td></tr>
</tbody></table>

## Exception at step 5

<table class="tableizer-table">
<tbody>
 <tr><td>User</td><td>UI</td><td>SYS</td><td>Drone</td></tr>
 <tr><td>5. If the user enables only the first(collision avoidance) and second levels OA(2D path planning)</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>6. Only enable the first and second level OA</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>7. Fly to the intermediate waypoints using 2D Obstacle Avoidance.</td></tr>
</tbody></table>

### Exception at step 6

<table class="tableizer-table">
<tbody>
 <tr><td>User</td><td>UI</td><td>SYS</td><td>Drone</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>6. The drone dynamically sensed new obstacles on the planned path</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>7. Enable collision avoidance to take control</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>8. Asks the drone to brake</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>9. The drone brakes. One of the two possibilities could happen: totally stop before a collision, or cannot hold the speed that the collision takes place.</td></tr>
</tbody></table>


## Use Case: Add new algorithms

<table class="tableizer-table">
<tbody>
<tr><td>User</td><td>UI</td><td>SYS</td><td>Drone</td></tr>
 <tr><td>1. User install a new algorithm to integrated OA system through the application manager or direct from source</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>2. Display the OAC change message</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>3. Dynamically configure OAC, leave FCU in a safe status add the new algorithm, adjust the scheduler to include this algorithm in the next cycle</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>4. Display the success message</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>5. The drone receives new path information from the new  algorithm </td></tr>
</tbody></table>

### Exception at step 3

<table class="tableizer-table">
<tbody>
 <tr><td>User</td><td>UI</td><td>Sys</td><td>Drone</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>3. Fail to compile the algorithm package</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>4. Halt the package installation</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>5. Briefly inform the user with the compiler error message. Suggest the user double check the algorithm package version.</td><td>&nbsp;</td><td></td></tr>
</tbody></table>

### Exception at step 3 

<table class="tableizer-table">
<tbody>
 <tr><td>User</td><td>UI</td><td>Sys</td><td>Drone</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>3. Fail to dynamically configure the algorithm</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>4. Temporarily disable this package</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>5. Briefly inform the user with the compiler error message. Suggest the user install statically instead</td><td>&nbsp;</td><td></td></tr>
</tbody></table>

## Use Case: OAC pause and resume

<table class="tableizer-table">
<tbody>
 <tr><td>User</td><td>UI</td><td>Sys</td><td>Drone</td></tr>
 <tr><td>1. The user turns off the OA</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>2. OAC record current status and temporarily pause</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>3. OAC sends a brake command to the drone</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>4. Trigger a drone brake event</td></tr>
 <tr><td>&nbsp;</td><td>5. Display event descrption and system status message</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>6. Keep listening to UI for OA related user input</td><td>&nbsp;</td></tr>
 <tr><td>7. The user turns on the OA</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>8. OAC re-enabled, read previous status and resume</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>9. Change the drone mode from brake to guided</td><td>&nbsp;</td></tr>
 <tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>10. Continue to generic step 8-9.</td></tr>
</tbody></table>
