# DroneOA Setup Script

## How to use the environment setup script
```shell
cd droneoa_ros/scripts/setup
chmod +x *
./ENV_script.sh
```
## How to start an ArduCopter instance
For the first time:
```shell
cd ~
cd <Ardupilot_Path>/ArduCopter
sim_vehicle.py -w
```
After that:
```shell
sim_vehicle.py -v ArduCopter
```
The developer can add `--console` for mavproxy console, and `--map` for satellite map view

## FAQ
### sim_vehicle.py command not found, what should I do?
Solutions:
- Rebooting / Sign out the user's computer.
- If still not found, try to manually find this script here: `<Ardupilot_Path>/Tools/autotest/sim_vehicle.py`

### The environment setup script is asking for a path, is it absolute?
Yes, the path is absolute path

### How to develop With VSCode?
Steps:
- Install plugin `ROS` and `C/C++` in VSCode extensions
- Build the ros workspace with `catkin_make -DCMAKE_EXPORT_COMPILE_COMMANDS=Yes`

### Package not found when try to roslaunch, what should I do?
source `setup.bash` or `setup.zsh` depends on the user's terminal preference
```
source <WORKSPACE_PATH>/devel/setup.bash
```
You can also add this to the end of `~/.bashrc`

### I have attached a YDLidar, why it still cannot found the lidar?
You need to create shortcut with name "/dev/ydlidar" for YDLIDAR
```
roscd ydlidar/startup
sudo chmod 777 ./*
sudo sh initenv.sh
```
