# Official Wiki For DronOA Project (OASIS)

DronOA_ROS:
[![pipeline status](http://gitlab.tuotuogzs.com/droneoa/droneoa_ros/badges/master/pipeline.svg)](http://gitlab.tuotuogzs.com/droneoa/droneoa_ros/commits/master)

Wiki: 
[![pipeline status](https://gitlab.tuotuogzs.com/droneoa/droneoa_gitbook/badges/master/pipeline.svg)](https://gitlab.tuotuogzs.com/droneoa/droneoa_gitbook/commits/master)

Revision: 0.1.1 latest-Dev branch

http://droneoa.tuotuogzs.net/droneoa_gitbook

---

## [Drone Developer Wiki](Developer/DevIndex.md)

This wiki is for users intended to develop drone application (including obstacle avoidance and path planning algorithm), learn drone development and ROS basics, experiment with drone in simulated environment or just want to create own customized GUI.

---

## [Advance Drone Operator Wiki](Consumer/ConsIndex.md)

This wiki is for Advance Drone Operator who intended to use DroneOA ROS direct to add extra obstacle avoidance feature on existing drone, use web-based ground station or just experiment with new features to provide valuable feedbacks to developers.

---

### Summary of SE463 SRS Documents
- [Abbreviation](Developer/Knowledge/Abbreviation.md)
- [Indrocution & Module Diagram](Developer/DevIndex.md)
- [Domain Model & Use case model](Developer/Knowledge/DMAndUC.md)
- [OAC Architecture And Design Requirements](Developer/Knowledge/Modules/OAC/OACIndex.md)
- [GUI Popup Design Pattern](Developer/Knowledge/Modules/GUI/AddNewPopup.md)
- User Interfaces:
    - [WebGUI](Consumer/GUI/GUIIndex.md) (There is a big overhaul comming, requirements may change after usability evaluation)
    - [Console](Developer/Knowledge/Modules/ConsoleManager.md) (See command instructions in [Command document](Developer/Knowledge/Modules/Command.md))
    - Message "API" for Apps (Same as above using console manager and the same command set with different priority setting)
    - Internal [Code API](http://droneoa.tuotuogzs.net/droneoa-api-wiki/annotated.html) (Current version is internal only and subject to change on each release)

#### Summary of SE463 Use cases

**This section contains high-level complex use case**

- [Obstacle Avoidance](Developer/Knowledge/Modules/OAC/OACUCs.md)
- [Web GUI](Developer/Knowledge/Modules/GUI/GUIUseCase.md)
- [Dynamic Configuration](Developer/Knowledge/DynamicConfiguration.md)

**This section contains low-level unit use case** (Single command level).

They are small cases with only one/no command involved and limited steps. Some system components are included to better illustrate certain exceptions.

Check out Web GUI and Obstacle Avoidance module documentation for more complex real world use cases.

The purpose of this section is to demenstrate exceptions and alternative related to low-level hardware or software issues. Or exceptions that could happen with high "frequency" (e.g. on each command call). So when no duplicated exceptions will need to include in the complex use cases.

- [Command Queue Formation Use Case](Developer/Knowledge/Modules/Command.md)
- [Single Command Use Cases](Developer/Knowledge/Modules/ConsoleManager.md)

---

## Building Wiki locally

To work locally with this wiki, the user will have to follow the steps below:

1. Clone or download this project
2. Install node.js and GitBook
```
npm install n stable -g
npm install gitbook-cli -g
gitbook init
```
3. Fetch GitBook's latest stable version `gitbook fetch latest`
4. Preview changes to the project: `gitbook serve`
5. Add content
6. Generate the website: `gitbook build` (optional)

Read more at [GitBook](https://www.gitbook.com/).

## Useful links

API wiki: http://droneoa.tuotuogzs.net/droneoa-api-wiki

Main DroneOA ROS Repo: https://gitlab.tuotuogzs.com/droneoa/droneoa_ros

UE4 SIM Repo: https://gitlab.tuotuogzs.com/droneoa/droneoa_ros_ue4_simulator

Ardupilot Official Repo: https://github.com/ArduPilot/ardupilot

## Credit
DroneOA Group 2020 :palm_tree:
Published with [Gitbook](https://www.gitbook.com/)
