# Setup UE4 and UE4 Simulator

## Install:

Remember to pull submodules
```shell
git submodule update --init --recursive
```

Setup Dependencies of ROSIntegration
```shell
sudo apt-get install ros-melodic-rosbridge-suite
```

## Install UE4 for Ubuntu 18.04
```shell
git clone https://github.com/EpicGames/UnrealEngine.git
# or if prefer ssh authentication: 
# git clone git@github.com:EpicGames/UnrealEngine.git
cd UnrealEngine
# Currently we only support 4.23 version
git checkout 4.23
./Setup.sh
```
Goto `PATH_TO_UNREAL/Engine/Source/Programs/UnrealBuildTool/Platform/Linux/LinuxToolChain.cs`, find the `GetCLArguments_Global` method and add `Result += " -mf16c";` at the end of the function.
```
./GenerateProjectFiles.sh
make
```
After compilation is finished. Test the engine with: `./Engine/Binaries/Linux/UE4Editor`

## Start The Visualizer For General Projects
1. Launch an ArduCopter SITL Instance

2. Launch a ROSBridge node
```shell
roslaunch rosbridge_server rosbridge_tcp.launch bson_only_mode:=True
```

3. Launch the python bridge script
```shell
python ./Scripts/simple_UDP.py
```

4. Launch the UE4 project an run the demo :)

## Start The Simulator For DroneOA
1. Launch an ArduCopter SITL Instace
```shell
sim_vehicle -v ArduCopter
```
2. Launch the UE4 engine
Double click MyProject.uproject inside the ue4_simulator folder
3. Launch the test.sh bash file inside the droneOA project
```shell
sudo -s
# In the droneOA project
cd scripts/testing
./sim_ue4.bash
```
